package RepositoryImpl

import Interface.PasswordService
import javax.crypto.SecretKeyFactory
import javax.crypto.spec.PBEKeySpec

class PasswordServiceImpl : PasswordService {
    override fun hashPassword(password: String, salt: ByteArray): String {
        val spec = PBEKeySpec(password.toCharArray(), salt, 10000, 256)
        val factory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA1")
        val hash = factory.generateSecret(spec).encoded
        return salt.joinToString("") { "%02x".format(it) } + ":" + hash.joinToString("") { "%02x".format(it) }
    }

    override fun matches(password: String, salt: ByteArray, hashedPassword: String): Boolean {
        val generatedHash = hashPassword(password, salt)
        return generatedHash == hashedPassword
    }
}

