package org.example.data.admin

import data.features.authorize.model.User
import domain.request.AuthorizeRequest
import domain.request.RegistrationRequest
import domain.response.UserPesponse
import io.github.serpro69.kfaker.Faker
import java.util.*

data class LocalUser(
    val uuid: UUID,
    var lastname: String,
    var firstname: String? = null,
    var email: String,
    var photo: String? = null,
    var password: String,
    var number: String? = null,
    var address: String? = null
)
val users = generateUsers(100).toMutableList()
fun generateUsers(userCount: Int): List<LocalUser>{
    val localUserList = mutableListOf<LocalUser>()
    val faker = Faker()
    repeat(userCount){
        localUserList.add(
            LocalUser(
                uuid = UUID.randomUUID(),
                lastname = faker.name.lastName(),
                firstname = faker.name.firstName(),
                email = faker.random.randomString(3)+"@mail.ru",
                photo= faker.random.randomString(10),
                password = faker.random.randomString(8),
                number = faker.phoneNumber.phoneNumber(),
                address = faker.address.fullAddress()
            )
        )

    }
    return localUserList
}

fun auth(authorizeRequest: AuthorizeRequest): User {
    val findUser = users.firstOrNull { it.email == authorizeRequest.email }
    checkNotNull(findUser) {
        "Пользователь не найден"
    }
    return if (findUser.password == authorizeRequest.password) User(
        uuid = findUser.uuid,
        firstname = findUser.firstname ?: "",
        lastname = findUser.lastname,
        email = findUser.email,
        photo = findUser.photo ?: "",
        number = findUser.number,
        address = findUser.address
    )
    else throw IllegalArgumentException("Пароли не совпадают")
}

fun registration(registrationRequest: RegistrationRequest): User {
    val user = LocalUser(
        uuid = UUID.randomUUID(),
        lastname = registrationRequest.lastname,
        email = registrationRequest.email,
        password = registrationRequest.password
    )

    users.add(user)
    return User(
        uuid = user.uuid,
        firstname = user.firstname ?: "",
        lastname = user.lastname,
        email = user.email,
        photo = user.photo ?: "",
        number = user.number,
        address = user.address
    )
}